> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List VIP available ports

> List all instance ports that are available for connecting to a VIP.



## OpenAPI

````yaml /api-reference/services_documented/cloud_api.yaml get /cloud/v1/reserved_fixed_ips/{project_id}/{region_id}/{port_id}/available_devices
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Cloud API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-15T06:37:28.230198+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: Bare Metal
    x-displayName: Bare Metal
  - name: Container as a Service
    x-displayName: Container as a Service
  - name: Cost Reports
    x-displayName: Cost Reports
  - name: DDoS Protection
    x-displayName: DDoS Protection
  - name: Everywhere Inference
    x-displayName: Everywhere Inference
  - name: Everywhere Inference Apps
    x-displayName: Everywhere Inference Apps
  - name: File Shares
    x-displayName: File Shares
  - name: Floating IPs
    x-displayName: Floating IPs
  - name: Function as a Service
    x-displayName: Function as a Service
  - name: GPU Bare Metal
    x-displayName: GPU Bare Metal
  - name: GPU Virtual
    x-displayName: GPU Virtual
  - name: IP Ranges
    x-displayName: IP Ranges
  - name: Images
    x-displayName: Images
  - name: Instances
    x-displayName: Instances
  - name: Load Balancers
    x-displayName: Load Balancers
  - name: Logging
    x-displayName: Logging
  - name: Managed Kubernetes
    x-displayName: Managed Kubernetes
  - name: Managed PostgreSQL
    x-displayName: Managed PostgreSQL
  - name: Networks
    x-displayName: Networks
  - name: Placement Groups
    x-displayName: Placement Groups
  - name: Projects
    x-displayName: Projects
  - name: Quotas
    x-displayName: Quotas
  - name: Regions
    x-displayName: Regions
  - name: Registry
    x-displayName: Registry
  - name: Reservations
    x-displayName: Reservations
  - name: Reserved IPs
    x-displayName: Reserved IPs
  - name: Routers
    x-displayName: Routers
  - name: SSH Keys
    x-displayName: SSH Keys
  - name: Secrets
    x-displayName: Secrets
  - name: Security Groups
    x-displayName: Security Groups
  - name: Snapshot Schedules
    x-displayName: Snapshot Schedules
  - name: Snapshots
    x-displayName: Snapshots
  - name: Tasks
    x-displayName: Tasks
  - name: User Actions
    x-displayName: User Actions
  - name: User Role Assignments
    x-displayName: User Role Assignments
  - name: Volumes
    x-displayName: Volumes
paths:
  /cloud/v1/reserved_fixed_ips/{project_id}/{region_id}/{port_id}/available_devices:
    get:
      tags:
        - Reserved IPs
      summary: List VIP available ports
      description: List all instance ports that are available for connecting to a VIP.
      operationId: ReservedFixedIPAddressPairsAvailableDevicesViewSet.get
      parameters:
        - in: path
          name: project_id
          required: true
          description: Project ID
          schema:
            type: integer
        - in: path
          name: region_id
          required: true
          description: Region ID
          schema:
            type: integer
        - in: path
          name: port_id
          required: true
          description: Port ID
          schema:
            type: string
      responses:
        '200':
          description: List of available instances
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/VIPAttachCandidateCollectionSerializer'
      x-codeSamples:
        - lang: Python
          source: >-
            import os

            from gcore import Gcore


            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )

            candidate_port_list =
            client.cloud.reserved_fixed_ips.vip.candidate_ports.list(
                port_id="port_id",
                project_id=0,
                region_id=0,
            )

            print(candidate_port_list.count)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/cloud\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tcandidatePortList, err := client.Cloud.ReservedFixedIPs.Vip.CandidatePorts.List(\n\t\tcontext.TODO(),\n\t\t\"port_id\",\n\t\tcloud.ReservedFixedIPVipCandidatePortListParams{\n\t\t\tProjectID: gcore.Int(0),\n\t\t\tRegionID:  gcore.Int(0),\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", candidatePortList.Count)\n}\n"
components:
  schemas:
    VIPAttachCandidateCollectionSerializer:
      properties:
        count:
          description: Number of objects
          example: 1
          examples:
            - 1
          minimum: 0
          title: Count
          type: integer
        results:
          description: Objects
          items:
            $ref: '#/components/schemas/VIPAttachCandidateSerializer'
          title: Results
          type: array
      required:
        - count
        - results
      title: VIPAttachCandidateCollectionSerializer
      type: object
    VIPAttachCandidateSerializer:
      properties:
        instance_id:
          description: ID of the instance that owns the port
          example: bc688791-f1b0-44eb-97d4-07697294b1e1
          examples:
            - bc688791-f1b0-44eb-97d4-07697294b1e1
          format: uuid4
          title: Instance Id
          type: string
        instance_name:
          description: Name of the instance that owns the port
          example: Virtual Machine 1
          examples:
            - Virtual Machine 1
          title: Instance Name
          type: string
        ip_assignments:
          description: IP addresses assigned to this port
          items:
            $ref: '#/components/schemas/PortIpWithSubnetSerializer'
          title: Ip Assignments
          type: array
        network:
          $ref: '#/components/schemas/NetworkSerializer'
          description: Network details
        port_id:
          description: Port ID that shares VIP
          example: 351b0dd7-ca09-431c-be53-935db3785067
          examples:
            - 351b0dd7-ca09-431c-be53-935db3785067
          format: uuid4
          title: Port Id
          type: string
      required:
        - port_id
        - instance_id
        - instance_name
        - network
        - ip_assignments
      title: VIPAttachCandidateSerializer
      type: object
    PortIpWithSubnetSerializer:
      properties:
        ip_address:
          description: IP address
          example: 192.168.123.20
          examples:
            - 192.168.123.20
          format: ipvanyaddress
          title: Ip Address
          type: string
        subnet:
          $ref: '#/components/schemas/SubnetSerializer'
          description: Subnet details
        subnet_id:
          description: ID of the subnet that allocated the IP
          example: b39792c3-3160-4356-912e-ba396c95cdcf
          examples:
            - b39792c3-3160-4356-912e-ba396c95cdcf
          format: uuid4
          title: Subnet Id
          type: string
      required:
        - subnet_id
        - ip_address
        - subnet
      title: PortIpWithSubnetSerializer
      type: object
    NetworkSerializer:
      properties:
        created_at:
          description: Datetime when the network was created
          example: 2019-06-18T11:56:16+0000
          examples:
            - 2019-06-18T11:56:16+0000
          format: date-time
          title: Created At
          type: string
        creator_task_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: Task that created this entity
          examples:
            - fd50fdd1-0482-4c9b-b847-fc9924665af6
          title: Creator Task Id
        default:
          anyOf:
            - type: boolean
            - type: 'null'
          description: True if network has `is_default` attribute
          examples:
            - true
          title: Default
        external:
          description: True if the network `router:external` attribute
          example: true
          examples:
            - true
          title: External
          type: boolean
        id:
          description: Network ID
          example: eed97610-708d-43a5-a9a5-caebd2b7b4ee
          examples:
            - eed97610-708d-43a5-a9a5-caebd2b7b4ee
          format: uuid4
          title: Id
          type: string
        mtu:
          description: MTU (maximum transmission unit). Default value is 1450
          example: 1500
          examples:
            - 1500
          title: Mtu
          type: integer
        name:
          description: Network name
          example: public
          examples:
            - public
          title: Name
          type: string
        port_security_enabled:
          description: >-
            Indicates `port_security_enabled` status of all newly created in the
            network ports.
          example: true
          examples:
            - true
            - false
          title: Port Security Enabled
          type: boolean
        project_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Project ID
          examples:
            - 1337
          title: Project Id
        region:
          description: Region name
          example: Luxembourg 1
          examples:
            - Luxembourg 1
          title: Region
          type: string
        region_id:
          description: Region ID
          example: 7
          examples:
            - 7
          title: Region Id
          type: integer
        segmentation_id:
          anyOf:
            - type: integer
            - type: 'null'
          description: Id of network segment
          examples:
            - 9
          title: Segmentation Id
        shared:
          description: True when the network is shared with your project by external owner
          example: false
          examples:
            - false
          title: Shared
          type: boolean
        subnets:
          description: List of subnetworks
          example:
            - f00624ab-41bc-4d54-a723-1673ce32d997
            - 41e0f698-4d39-483b-b77a-18eb070e4c09
          examples:
            - - f00624ab-41bc-4d54-a723-1673ce32d997
              - 41e0f698-4d39-483b-b77a-18eb070e4c09
          items:
            format: uuid4
            type: string
          title: Subnets
          type: array
        tags:
          description: >-
            List of key-value tags associated with the resource. A tag is a
            key-value pair that can be associated with a resource, enabling
            efficient filtering and grouping for better organization and
            management. Some tags are read-only and cannot be modified by the
            user. Tags are also integrated with cost reports, allowing cost data
            to be filtered based on tag keys or values.
          example:
            - key: my-tag
              read_only: false
              value: my-tag-value
          examples:
            - - key: my-tag
                read_only: false
                value: my-tag-value
          items:
            $ref: '#/components/schemas/TagSerializer'
          title: Tags
          type: array
        task_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          description: >-
            The UUID of the active task that currently holds a lock on the
            resource. This lock prevents concurrent modifications to ensure
            consistency. If `null`, the resource is not locked.
          examples:
            - null
          title: Task Id
        type:
          description: Network type (vlan, vxlan)
          example: vlan
          examples:
            - vlan
          title: Type
          type: string
        updated_at:
          description: Datetime when the network was last updated
          example: 2019-06-18T11:57:00+0000
          examples:
            - 2019-06-18T11:57:00+0000
          format: date-time
          title: Updated At
          type: string
      required:
        - project_id
        - region_id
        - region
        - id
        - name
        - mtu
        - created_at
        - updated_at
        - type
        - segmentation_id
        - external
        - default
        - shared
        - subnets
        - creator_task_id
        - task_id
        - tags
        - port_security_enabled
      title: NetworkSerializer
      type: object
    SubnetSerializer:
      properties:
        available_ips:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: Number of available ips in subnet
          examples:
            - 250
          title: Available Ips
        cidr:
          description: CIDR
          example: 192.168.13.0/24
          examples:
            - 192.168.13.0/24
          format: ipvanynetwork
          title: Cidr
          type: string
        created_at:
          description: Datetime when the subnet was created
          example: 2019-06-13T13:58:12+0000
          examples:
            - 2019-06-13T13:58:12+0000
          format: date-time
          title: Created At
          type: string
        creator_task_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          default: null
          description: Task that created this entity
          examples:
            - 5cc890da-d031-4a23-ac31-625edfa22812
          title: Creator Task Id
        dns_nameservers:
          anyOf:
            - items:
                format: ipvanyaddress
                type: string
              type: array
            - type: 'null'
          default: null
          description: List IP addresses of a DNS resolver reachable from the network
          examples:
            - - 8.8.8.8
              - 8.8.4.4
          title: Dns Nameservers
        enable_dhcp:
          description: True if DHCP should be enabled
          example: true
          examples:
            - true
          title: Enable Dhcp
          type: boolean
        gateway_ip:
          anyOf:
            - format: ipvanyaddress
              type: string
            - type: 'null'
          default: null
          description: >-
            Default GW IPv4 address, advertised in DHCP routes of this subnet.
            If null, no gateway is advertised by this subnet.
          examples:
            - 192.168.13.1
          title: Gateway Ip
        has_router:
          default: false
          deprecated: true
          description: Deprecated. Always returns `false`.
          example: false
          examples:
            - false
          title: Has Router
          type: boolean
        host_routes:
          anyOf:
            - items:
                $ref: '#/components/schemas/RouteOutSerializer'
              type: array
            - type: 'null'
          default: null
          description: List of custom static routes to advertise via DHCP.
          examples:
            - []
          title: Host Routes
        id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          default: null
          description: Subnet id.
          examples:
            - b39792c3-3160-4356-912e-ba396c95cdcf
          title: Id
        ip_version:
          $ref: '#/components/schemas/IPVersion'
          description: IP version
          examples:
            - 4
        name:
          description: Subnet name
          example: subnet_3
          examples:
            - subnet_3
          pattern: ^[a-zA-Z0-9][a-zA-Z 0-9._\-]{1,61}[a-zA-Z0-9._]$
          title: Name
          type: string
        network_id:
          description: Network ID
          example: b30d0de7-bca2-4c83-9c57-9e645bd2cc92
          examples:
            - b30d0de7-bca2-4c83-9c57-9e645bd2cc92
          format: uuid4
          title: Network Id
          type: string
        project_id:
          description: Project ID
          example: 1337
          examples:
            - 1337
          title: Project Id
          type: integer
        region:
          description: Region name
          example: Luxembourg 1
          examples:
            - Luxembourg 1
          title: Region
          type: string
        region_id:
          description: Region ID
          example: 7
          examples:
            - 7
          title: Region Id
          type: integer
        tags:
          description: >-
            List of key-value tags associated with the resource. A tag is a
            key-value pair that can be associated with a resource, enabling
            efficient filtering and grouping for better organization and
            management. Some tags are read-only and cannot be modified by the
            user. Tags are also integrated with cost reports, allowing cost data
            to be filtered based on tag keys or values.
          example:
            - key: my-tag
              read_only: false
              value: my-tag-value
          examples:
            - - key: my-tag
                read_only: false
                value: my-tag-value
          items:
            $ref: '#/components/schemas/TagSerializer'
          title: Tags
          type: array
        task_id:
          anyOf:
            - format: uuid4
              type: string
            - type: 'null'
          default: null
          description: >-
            The UUID of the active task that currently holds a lock on the
            resource. This lock prevents concurrent modifications to ensure
            consistency. If `null`, the resource is not locked.
          examples:
            - null
          title: Task Id
        total_ips:
          anyOf:
            - type: integer
            - type: 'null'
          default: null
          description: Total number of ips in subnet
          examples:
            - 253
          title: Total Ips
        updated_at:
          description: Datetime when the subnet was last updated
          example: 2019-06-13T13:58:12+0000
          examples:
            - 2019-06-13T13:58:12+0000
          format: date-time
          title: Updated At
          type: string
      required:
        - project_id
        - region_id
        - region
        - name
        - network_id
        - ip_version
        - enable_dhcp
        - cidr
        - tags
        - created_at
        - updated_at
      title: SubnetSerializer
      type: object
    TagSerializer:
      description: >-
        A tag is a key-value pair that can be associated with a resource,

        enabling efficient filtering and grouping for better organization and
        management.

        Some tags are read-only and cannot be modified by the user.

        Tags are also integrated with cost reports, allowing cost data to be
        filtered based on tag keys or values.
      properties:
        key:
          description: >-
            Tag key. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag
          examples:
            - my-tag
          title: Key
          type: string
        read_only:
          description: If true, the tag is read-only and cannot be modified by the user
          example: false
          examples:
            - false
          title: Read Only
          type: boolean
        value:
          description: >-
            Tag value. Maximum 255 characters. Cannot contain spaces, tabs,
            newlines, empty string or '=' character.
          example: my-tag-value
          examples:
            - my-tag-value
          title: Value
          type: string
      required:
        - key
        - value
        - read_only
      title: TagSerializer
      type: object
    RouteOutSerializer:
      properties:
        destination:
          description: CIDR of destination IPv4 or IPv6 subnet.
          example: 10.0.3.0/24
          examples:
            - 10.0.3.0/24
          format: ipvanynetwork
          title: Destination
          type: string
        nexthop:
          description: >-
            IPv4 or IPv6 address to forward traffic to if it's destination IP
            matches 'destination' CIDR.
          example: 10.0.0.13
          examples:
            - 10.0.0.13
          format: ipvanyaddress
          title: Nexthop
          type: string
      required:
        - destination
        - nexthop
      title: RouteOutSerializer
      type: object
    IPVersion:
      enum:
        - 4
        - 6
      title: IPVersion
      type: integer
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````